// Copyright (C) 2025 Johannes Knödtel
// Full notice in 'LICENSE'

#pragma once

#define LIMIT_OMP 30

struct baseNode
{
    char character;
    struct baseNode *nextBase;
    struct repetitionNode *nextRep;
};

typedef struct baseNode baseNode;

struct repetitionNode
{
    int N;
    int lengthOfNode;
    struct repetitionNode *firstRep;
    struct baseNode *firstBase;
    struct repetitionNode *lastRep;
    struct baseNode *lastBase;
    struct baseNode *nextBase;
    struct repetitionNode *nextRep;
};

typedef struct repetitionNode repetitionNode;

void detect_repetitions(repetitionNode *origNode, char signs[], int length);
void printRepNode(repetitionNode *a);
repetitionNode *initRepNode(int n);
