#!/usr/bin/env python3

from performance import generate_random_bytes, generate_random_hier

depths = [4, 8, 16, 32]
maxlen_seqs = [0.25, 0.5, 0.75, 1]

for i in range(1, 4):
    l = 1024*8*i
    data = generate_random_bytes(length=l)
    with open(f'examples/example-flat-{l=}-{i=}.bin', 'wb') as f:
        f.write(data)
    # for depth in depths:
    #     for maxlen_seq in maxlen_seqs:
    #         data = generate_random_hier(length=l, seed=42, depth=depth, maxlen_seq=maxlen_seq * l)
    #         with open(f'examples/example-hier-{l=}-{depth=}-{maxlen_seq=}.bin', 'wb') as f:
    #             f.write(data)
